'use strict';

angular.module('magooshFlashcardApp').controller('AccountController', ['$scope', '$location', '$q', 'Auth', function($scope, $location, $q, Auth){
  $scope.user = null;
  $scope.exam = magooshHost.split('.')[0].toUpperCase();
  $scope.errorMessages = [];
  $scope.forgotPasswordUrl = magooshHost + "/forgot_password";
  
  $scope.user = null;
  Auth.user().then(function(user){
    $scope.user = user;
  });
  
  // Validate the form and resolve the returned promise if all fields are valid
  var validateForm = function(){
    var deferred = $q.defer();
    
    if ($scope.form.$pristine){
      // trigger change event to force display of validation errors
      $scope.form.email.$setViewValue($('input#email').val());
      deferred.reject();
    } else if ($scope.form.email.$valid && $scope.form.password.$valid) {
      deferred.resolve();
    } else {
      deferred.reject();
    }
    
    return deferred.promise;
  };
  
  var disableForm = function(){
    // Disable form inputs
    $('input, .btn-create-account').attr('disabled', 'disabled');
  };
  
  var enableForm = function(){
    // Re-enable form
    $('.btn').button('reset');
    $('input').removeAttr('disabled');
  };
  
  // Helper to redirect when there's a stored auth token
  var handleLoginSuccess = function(){
    gaRecordEvent("Event", "Login", "success", 1);
    console.log('Successful login. Redirecting...');
    $location.path('/decks/').replace();
  };
  
  var handleLoginFailure = function(errors){
    gaRecordEvent("Event", "Login", "error", 1);
    $scope.errorMessages = errors.slice(0,1); // only use the first error
    enableForm();
  }
  
  $scope.login = function (){
    validateForm().then(function(){
      disableForm();
      gaRecordEvent("Button", "Click", "login", 1);
      
      Auth.login($scope.form.email.$modelValue, $scope.form.password.$modelValue)
        .then(handleLoginSuccess, handleLoginFailure);
    });
  };
  
  $scope.createAccount = function (){
    validateForm().then(function(){
      disableForm();
      gaRecordEvent("Button", "Click", "create_account", 1);
      
      Auth.createAccount($scope.form.email.$modelValue, $scope.form.password.$modelValue)
        .then(handleLoginSuccess, handleLoginFailure);
    });
  };
  
  $scope.logout = function(){
    console.log("Starting logout()");
    Auth.logout().then(function(){
      $location.path('/decks').replace();
    });
    gaRecordEvent("Button", "Click", "logout", 1);
  };
}]);
