'use strict';

angular.module('magooshFlashcardApp').controller('DecksController', ['$scope', 'Deck', 'persistencejs', '$location', function ($scope, Deck, persistencejs, $location) {
  $scope.setName = flashcardDeckSetName;
  
  $scope.decks = [];
  $scope.errorMessage = '';
  
  $scope.loadDecks = function(){
    // reset UI to loading state
    $scope.decks = [];
    $scope.errorMessage = '';
    
    // load decks from storage
    Deck.all().then(function(decks){
      $scope.decks = decks;
    }, function(error_message){
      $scope.errorMessage = error_message;
    });
  };
  
  $scope.$on('Deck::Updated', $scope.loadDecks);
  $scope.loadDecks();

  var trackInstallDate = function() {
    persistencejs.getSessionData('install_date').then(function(date) {
      if (!date) {
        var today = new Date().getTime(); // Timestamp in milliseconds
        persistencejs.setSessionData('install_date', today);
      }
    });
  };

  persistencejs.getSessionData('form:viewed.install').then(function(seen) {
    if (!seen) {
      $location.path('/feedback/install').replace();
      trackInstallDate();
    } else {
      persistencejs.getSessionData('form:viewed.returnUser').then(function(seenReturnForm) {
        persistencejs.getSessionData('install_date').then(function(install) {
          if (!install) {
            return;
          }
          var today = new Date().getTime();
          var oldEnough = (install + 2 * 24 * 60 * 60 * 1000) < today; // installed at least 2 days ago
          if (!seenReturnForm && oldEnough) {
            $location.path('/feedback/returnUser').replace();
          }
        });
      });
    }
  });

}]);
