'use strict';

angular.module('magooshFlashcardApp').controller('NavbarController', ['$scope', '$location', '$rootScope', 'Auth', function($scope, $location, $rootScope, Auth){
  $scope.loggedIn = false;
  
  var checkLogin = function(){
    Auth.user().then(function(user){
      $scope.loggedIn = true;
    }, function(){
      $scope.loggedIn = false;
    });
  };
  
  $rootScope.$on('Auth::Updated', checkLogin);
  checkLogin();
  
  var hideNavMenu = function(){
    if($('.nav-collapse').hasClass('in')){
      $('.nav-collapse').collapse('hide');
    }
  };
  
  $scope.navLink = function(path) {
    hideNavMenu();
    $location.path(path);
  }
  
  $scope.$on('$routeChangeStart', function(next, current) {
    hideNavMenu();
  });
}]);
