'use strict';

angular.module('magooshFlashcardApp').controller('SettingsController', ['$scope', '$rootScope', '$location', 'Deck', function($scope, $rootScope, $location, Deck){
  
  $scope.syncErrorMessage = '';
  $scope.syncDecks = function(){
    // Show progress in UI
    $('#syncDecks').button('loading');
    $scope.syncErrorMessage = '';
  
    Deck.sync().then(function(){
      // Reset UI
      $('#syncDecks').button('reset');
      // Redirect to /decks
      $location.path('/decks').replace();
    }, function(messages){
      console.log(messages);
      // Reset UI
      $('#syncDecks').button('reset');
      // Show error message
      $scope.syncErrorMessage = messages[0];
    });
    gaRecordEvent("Button", "Click", "resetDecks", 1);
  };
  
  $scope.totalProgress = {cards_count: 0, mastered_cards_count: 0, card_name_plural: 'cards'};
  var loadProgress = function(){
    Deck.all().then(function(decks){
      $scope.totalProgress = {cards_count: 0, mastered_cards_count: 0, card_name_plural: decks[0].card_name_plural};
      for(var i=0; i < decks.length; i++){
        $scope.totalProgress.cards_count += decks[i].cards_count;
        $scope.totalProgress.mastered_cards_count += decks[i].mastered_cards_count;
        if (decks[i].card_name_plural != $scope.totalProgress.card_name_plural) {
          $scope.totalProgress.card_name_plural = 'cards';
        }
      }
    });
  };
  loadProgress();
  
  $scope.resetErrorMessage = '';
  $scope.resetAnswers = function(){
    // show progress in UI
    $('#resetAnswers').button('loading');
    $scope.resetErrorMessage = "";
    
    Deck.reset().then(function(){
      // reset UI
      $('#resetAnswers').button('reset');
      // redirect to /decks
      $location.path('/decks').replace();
    }, function(messages){
      // reset UI
      $('#resetAnswers').button('reset');
      // show error message
      $scope.resetErrorMessage = messages[0];
    });
    gaRecordEvent("Button", "Click", "resetAnswers", 1);
  };
  $scope.restoreAnswers = function(){
    // show progress in UI
    $('#resetAnswers, #restoreAnswers').button('restoring');
    $scope.resetErrorMessage = "";
    
    Deck.restore().then(function(){
      // reset UI
      $('#resetAnswers, #restoreAnswers').button('reset');
      // redirect to /decks
      $location.path('/decks').replace();
    }, function(messages){
      // reset UI
      $('#resetAnswers, #restoreAnswers').button('reset');
      // show error message
      $scope.resetErrorMessage = messages[0];
    });
    gaRecordEvent("Button", "Click", "restoreAnswers", 1);
  };
}]);
