'use strict';

angular.module('magooshFlashcardApp').directive('readOnChange', ['$sniffer', function($sniffer){
  return {
    restrict: 'A', // restrict to an attribute type
    require: 'ngModel', // element must have an ng-model attribute
    // scope = the parent scope
    // elem = the element the directive is on
    // attr = a dictionary of attributes on the element
    // ctrl = the controller for ngModel
    link: function(scope, element, attrs, ctrl){

      if ($sniffer.hasEvent('input')) {
        element.unbind('input').bind('input blur change', function(event){
          if (event.type == 'input') {
            // Only read on input if the current value is invalid
            if (ctrl.$invalid) {
              scope.$apply(read);
            }
          } else {
            scope.$apply(read);
          }
        });
      } else {
        // Listen for change events to enable binding, but not keyup events
        element.bind('blur change', function(event){
          scope.$apply(read);
        });
      }
      
      // Write data to the model
      function read() {
        ctrl.$setViewValue(element.val());
      }
    }
  }
}]);
