'use strict';

angular.module('magooshFlashcardApp').directive('validatePasswordLength', function() {
  return {
    // restrict to an attribute type
    restrict: 'A',
    
    // element must have an ng-model attribute
    require: 'ngModel', 
    
    // scope = the parent scope
    // elem = the element the directive is on
    // attr = a dictionary of attributes on the element
    // ctrl = the controller for ngModel
    link: function(scope, element, attrs, ctrl) {
    
      // add a parser that will process each time the value is
      // parsed into the model when the user updates it
      ctrl.$parsers.unshift(function(value){
        // check length and set validity
        ctrl.$setValidity('minlength', (value.length >= 6));
        
        // return the same value passed in
        return value;
      });
    }
  }
});
