angular.module('magooshFlashcardFilters', [])
  .filter('progressPercentage', function() {
    return function(deck, category) {
      if (deck) {
        return (100.0 * deck[category + '_cards_count'] / deck.cards_count) + '%';
      } else {
        return '0%';
      }
    };
  }).filter('learningStateClass', function() {
    return function(card) {
      if (card) {
        return {
          'new': '',
          'learning': 'danger',
          'reviewing': 'warning',
          'mastered': 'success'
        }[card.learning_state]
      } else {
        return '';
      }
    }
  }).filter('learningStateLabel', function() {
    return function(card) {
      if (card) {
        return {
          'new': 'NEW WORD',
          'learning': 'LEARNING',
          'reviewing': 'REVIEWING',
          'mastered': 'MASTERED'
        }[card.learning_state]
      } else {
        return '...';
      }
    }
  }).filter('flashcardEntryClass', function() {
    return function (entry){
      html_classes = ['flashcard-' + entry.type];
      if (typeof entry.styles !== 'undefined') {
        entry.styles.forEach(function(style){
          html_classes.push('flashcard-' + style);
        });
      } 
      return html_classes.join(' ');
    }
  });